<?

/*
All source code copyright and proprietary Melonfire, 2001. All content, brand names and trademarks copyright and proprietary Melonfire, 2001. All rights reserved. Copyright infringement is a violation of law.

This source code is provided with NO WARRANTY WHATSOEVER. It is meant for illustrative purposes only, and is NOT recommended for use in production environments. 

Read more articles like this one at http://www.melonfire.com/community/columns/trog/ and http://www.melonfire.com/
*/

// menu.class.php v1.0
// methods to obtain node and tree relationships

class Menu {

// set up some variables to hold database parameters
// hostname, user and password
var $hostname;
var $user;
var $password;
// database and table containing menu data
var $db;
var $table;

	// constructor
	function Menu()
	{
	$this->set_database_parameters("localhost", "root", "h7494hjs", "test", "menu");
	}

	// function: get next level of menu tree
	// returns: array
	function get_children($id)
	{
		$query = "SELECT id, label, link FROM $this->table WHERE parent = '$id'";	
		$result = $this->query($query);
		$count = 0;
		while ($row = mysql_fetch_array($result))
		{
			$children[$count]["id"] = $row["id"];	
			$children[$count]["label"] = $row["label"];	
			$children[$count]["link"] = $row["link"];	
			$count++;
		}
		return $children;
	}
	

	// function: return a list of this node's parents
	// by travelling upwards all the way to the root of the tree
	// returns: array
	function get_ancestors($id, $count = 0) 
	{
		// get parent of this node
		$parent = $this->get_parent($id);
		// if not at the root, add to $ancestors[] array
		if($parent)
		{
		$this->ancestors[$count]["id"] = $parent;
		$this->ancestors[$count]["label"] = $this->get_label($parent);
		$this->ancestors[$count]["link"] = $this->get_link($parent);
		// recurse to get the parent of this parent
		$this->get_ancestors($this->ancestors[$count]["id"], $count+1);
		// all done? at this stage the array contains a list in bottom-up order
		// reverse the array and return
		return array_reverse($this->ancestors);
		}
	}

	// function: is this node at the root of the tree?
	// returns: boolean
	function is_root_node($id)
	{
		if($this->get_parent($id) == 0)
		{
			return 1;
		}
		else
		{
			return 0;
		}
	}

	// function: get parent
	// returns: node id
	function get_parent($id)
	{
		$query = "SELECT parent FROM $this->table WHERE id = '$id'";	
		$result = $this->query($query);
		$row = mysql_fetch_row($result);
		return $row[0];
	}


	// function: get whether this id is a branch or leaf
	// returns: boolean
	function get_type($id)
	{
		if($this->get_children($id))
		{ 
			return 1; 
		}
		else
		{ 
			return 0; 
		}
	}

	// function: get label for $id
	// returns: string
	function get_label($id)
	{
		$query = "SELECT label FROM $this->table WHERE id = '$id'";	
		$result = $this->query($query);
		$row = mysql_fetch_row($result);
		return $row[0];
	}

	// function: get link for $id
	// returns: string
	function get_link($id)
	{
		$query = "SELECT link FROM $this->table WHERE id = '$id'";	
		$result = $this->query($query);
		$row = mysql_fetch_row($result);
		return $row[0];
	}

	// function: display complete menu tree (useful when debugging)
	// returns: HTML list
	function print_menu_tree($id = 0) 
	{
		$result = $this->get_children($id);	
		echo "<ul>";
		for ($x=0; $x<sizeof($result); $x++)
		{
			echo "<li>" . $result[$x]["label"] . "[" . $result[$x]["id"] . "]"; 
			$this->print_menu_tree($result[$x]["id"]);	
		}
		echo "</ul>";
	}
	
	// function: add a record to the menu table
	function create_node($label, $link, $parent) 
	{
	$this->query("INSERT INTO $this->table(label, link, parent) VALUES ('$label', '$link', '$parent')");
	}
	
	// function: remove a record from the menu table
	function remove_node($id) 
	{
	$this->query("DELETE FROM $this->table WHERE id = '$id'");
	}

	// function: execute query $query
	// returns: result identifier
	function query($query)
	{
	// connect
	$connection = mysql_connect($this->hostname, $this->user, $this->password) or die ("Cannot connect to database");
	// run query
	$ret = mysql_db_query($this->db, $query, $connection) or die ("Error in query: $query");
	// return result identifier
	return $ret;
	}

	// function: set database parameters
	// returns: none 
	function set_database_parameters($hostname, $user, $password, $db, $table)
	{
		$this->hostname = $hostname;
		$this->user = $user;
		$this->password = $password;
		$this->db = $db;
		$this->table = $table;
	}

// end
}

?>